/*
 *
 *  Copyright (C) 2014 Jürg Müller, CH-5524
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation version 3 of the License.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program. If not, see http://www.gnu.org/licenses/ .
 */

#if !defined(KTcpCanClient_H) 

  #define KTcpCanClient_H

  #include "KIpSocket.h"
  #include "NCanUtils.h"

  class KTcpCanClient : public KIpSocket
  {
    private:
      char mRemotePath[256];
      int ContentLength;
    
      bool TraceReceive(int Length);
      bool ReceiveBuffer(char * Buffer, int BufferLen);
    public:
      bool Trace;
      bool mConnected;
    
      KTcpCanClient();
    
      bool SendBuffer(const char * aBuffer, int aLength, int TimeOut = 1000);
      bool WriteLine(const char * aBuffer);
      bool ReadLine(char * aString, int aLength);
      bool ReadHttpStream(char * & aStream, int & aStreamLen, const char * aGetString);
      bool PutHttpStream(const char * aStream);
      bool ReadElster(char * Buffer);
      bool SendElster(char * Buffer, int timeout);
      bool SendComfortFrame(const KComfortFrame & send, KComfortFrame & recv);
    
      bool Connect(int aTimeout = 10);
      void Disconnect();
    
  };



#endif

