
// Beispiel "spam" siehe
//
// https://docs.python.org/2/extending/extending.html
//
// Leider funktioniert das Beispiel nur unter python 2 nicht aber unter 3.
//

// Compilation:
//
// gcc -shared -fPIC -I/usr/include/python2.7 -lc -lpython2.7 spammodule.c -o spam.so

// Test:
// >>>import spam
// >>>status = spam.system("ls -l")
//

#include <Python.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

static PyObject *SpamError;

static PyObject * spam_system(PyObject *self, PyObject *args)
{
  const char *command;
  int sts;
  
  if (!PyArg_ParseTuple(args, "s", &command))
    return NULL;
  
  sts = system(command);
  if (sts < 0)
  {
    PyErr_SetString(SpamError, "System command failed");
    return NULL;
  }
  return PyLong_FromLong(sts);
}

static PyMethodDef SpamMethods[] =
{
  {"system",  spam_system, METH_VARARGS, "Execute a shell command."},
  {NULL, NULL, 0, NULL}
};

//PyMODINIT_FUNC
extern void initspam(void)
{
  (void) Py_InitModule("spam", SpamMethods);
}

int main(int argc, char *argv[])
{
  int i;
  /* Pass argv[0] to the Python interpreter */
/*  wchar_t name[1024];
  for (i = 0; i <= strlen(argv[0]); i++)
    name[i] = argv[0][i]; */
  
  Py_SetProgramName(argv[0]);
  
  /* Initialize the Python interpreter.  Required. */
  Py_Initialize();
  
  /* Add a static module */
  initspam();
  
  return 0;
}
